#include "..\systray.h"
#include <dos.h>
#include <ctype.h>

char    szClockClass[] = "SystrayClockClass";

typedef struct _UNITCLOCK {
UNIT    u;
BYTE    bZero;
LONG    lfc,lbc;
CHAR    szFont[80];
BOOL    bShowSeconds;
BOOL    b12Hour;
BOOL    bShowDate;
} UNITCLOCK;

typedef UNITCLOCK *PUNITCLOCK;

extern HAB     habMain;
extern HMODULE hmod;

// clock unit dialog proc

MRESULT EXPENTRY clockdlgproc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
static PUNITCLOCK punit;
switch(msg)
{
case WM_INITDLG:
punit = (PUNITCLOCK) mp2;
WinCheckButton(hwnd,102,punit->bShowSeconds);
WinCheckButton(hwnd,103,punit->b12Hour);
WinCheckButton(hwnd,104,punit->bShowDate);
break;
case WM_COMMAND:
switch((SHORT)mp1)
{
case DID_OK:
punit->bShowSeconds=WinQueryButtonCheckstate(hwnd,102);
punit->b12Hour=WinQueryButtonCheckstate(hwnd,103);
punit->bShowDate=WinQueryButtonCheckstate(hwnd,104);
break;
}
break;
}
return WinDefDlgProc(hwnd,msg,mp1,mp2);
}

// clock unit window proc

char *months[]={"Jan","Feb","Mar","Apr","May","Jun",
                "Jul","Aug","Sep","Oct","Nov","Dec"};
char *dayowk[]={"Sunday","Monday","Tuesday","Wednesday",
                "Thursday","Friday","Saturday"};

void	gettime(char *buf,PUNITCLOCK punit)
{
struct dostime_t mytime;
struct dosdate_t mydate;
_dos_gettime(&mytime);
if(punit->bShowSeconds)
{
if(!punit->b12Hour)
sprintf(buf,"%02d:%02d:%02d",mytime.hour,mytime.minute,mytime.second);
else
sprintf(buf,"%02d:%02d:%02d%cm",((mytime.hour==0)||(mytime.hour==12)) ? 12 : mytime.hour%12,
mytime.minute,mytime.second,mytime.hour>11 ? 'p' : 'a');
}
else
{
if(!punit->b12Hour)
sprintf(buf,"%02d%c%02d",mytime.hour,(mytime.second&1) ? ':' : ' ',mytime.minute);
else
sprintf(buf,"%02d%c%02d%cm",((mytime.hour==0)||(mytime.hour==12)) ? 12 : mytime.hour%12,
(mytime.second&1) ? ':' : ' ',mytime.minute,mytime.hour>11 ? 'p' : 'a');
}
if(punit->bShowDate)
{
_dos_getdate(&mydate);
sprintf(buf,"%s %s, %d",buf,months[mydate.month-1],mydate.day);
}
}

MRESULT EXPENTRY clockwndproc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
HWND hwndTime;
struct dostime_t mytime;
struct dosdate_t mydate;
PUNITCLOCK punit;
HPS hps;
RECTL rcl;
ULONG x;
char buf[80];
punit = (PUNITCLOCK)WinQueryWindowULong(hwnd,0L);
switch(msg)
{
case WM_CREATE:
punit = (PUNITCLOCK)mp1;
WinSetWindowULong(hwnd,0L,(ULONG)punit);
if(!punit->bZero)
{

punit->lfc = 0L;
punit->lbc = 0x00CCCCCCL;
strcpy(punit->szFont,"8.Helv");
punit->bShowSeconds = TRUE;
punit->b12Hour = TRUE;
punit->bShowDate = FALSE;
punit->bZero = 1;
}

WinQueryWindowRect(hwnd, &rcl);
gettime(buf,punit);
/* new static text window for easy output */
hwndTime = WinCreateWindow(hwnd, WC_STATIC, buf, 
		           WS_VISIBLE | SS_TEXT | DT_CENTER | DT_VCENTER,
			   1, 1, rcl.xRight-2, rcl.yTop-2, hwnd, HWND_TOP,
			   100, NULL, NULL);
_dos_getdate(&mydate);
sprintf(punit->u.szBubble,"%s, %d",months[mydate.month-1],mydate.day);
WinSetPresParam(hwndTime, PP_FONTNAMESIZE,80,punit->szFont);
WinSetPresParam(hwndTime, PP_BACKGROUNDCOLOR,sizeof(LONG),&punit->lbc);
WinSetPresParam(hwndTime, PP_FOREGROUNDCOLOR,sizeof(LONG),&punit->lfc);
WinStartTimer(habMain, hwnd, 1, 1000);
/* set bubble help buffer pointer */
WinSendMsg(WinQueryWindow(hwnd,QW_PARENT),WM_USER,(MPARAM)hwndTime,
           (MPARAM)punit->u.szBubble);
break;
case WM_TIMER:
gettime(buf,punit);
WinSetWindowText(WinWindowFromID(hwnd,100),buf);
WinQueryPresParam(WinWindowFromID(hwnd,100), PP_FONTNAMESIZE,NULL,&x,80,buf,0);
strcpy(punit->szFont,buf);
WinQueryPresParam(WinWindowFromID(hwnd,100), PP_BACKGROUNDCOLOR,NULL,&x,sizeof(LONG),&punit->lbc,QPF_PURERGBCOLOR);
WinQueryPresParam(WinWindowFromID(hwnd,100), PP_FOREGROUNDCOLOR,NULL,&x,sizeof(LONG),&punit->lfc,QPF_PURERGBCOLOR);
_dos_getdate(&mydate);
sprintf(punit->u.szBubble,"%s %d, %s",months[mydate.month-1],mydate.day,
        dayowk[mydate.dayofweek]);
break;
case WM_SIZE:
WinSetWindowPos(WinWindowFromID(hwnd,100),HWND_TOP,0,0,
                SHORT1FROMMP(mp2)-2,SHORT2FROMMP(mp2)-2,SWP_SIZE); 
break;
case WM_PAINT:
hps = WinBeginPaint(hwnd,NULL,NULL);
WinQueryWindowRect(hwnd, &rcl);
WinDrawBorder(hps,&rcl,1,1,CLR_DARKGRAY,CLR_WHITE,0x800L);
WinEndPaint(hps);
return (MRESULT) NULL;
case WM_COMMAND:
switch((SHORT)mp1)
{
case 100:
/* invoke configuration dialog */
WinDlgBox(HWND_DESKTOP,(HWND)mp2,(PFNWP)clockdlgproc,hmod,100,(PVOID)punit);
break;
}
return (MRESULT) NULL;
case WM_DESTROY:
DosFreeMem(punit); /* free unit memory */
break;
}
return WinDefWindowProc(hwnd,msg,mp1,mp2);
}

void clockregisterclass(PWCLASS pwc)
{
strcpy(pwc->szName,szClockClass);
pwc->ulCfgSize = sizeof(UNITCLOCK);
pwc->ulSafeAlloc = sizeof(UNITCLOCK);
pwc->bInitalUnitWidthPercent = 10;
WinRegisterClass(habMain,(PSZ)szClockClass,(PFNWP)clockwndproc,CS_SIZEREDRAW,4L);
}
