#include "..\systray.h"
#include <dos.h>
#include <ctype.h>

char    szDiskClass[] = "SystrayDiskMonitorClass";
char    szHelp[] = "Free space monitor";

extern HAB     habMain;
extern HMODULE hmod;

HPOINTER        hptrDiskIcon;

typedef struct _UNITDISKMON {
UNIT    unit;
BYTE    bZero;
CHAR    chDrive;
CHAR    chRes[2];
LONG    lfc,lbc;
CHAR    szFont[80];
} UNITDISKMON;

typedef UNITDISKMON *PUNITDISKMON;

MRESULT EXPENTRY diskmondlgproc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
static PUNITDISKMON punit;
switch(msg)
{
case WM_INITDLG:
punit = (PUNITDISKMON)mp2;
WinSendDlgItemMsg(hwnd,303,EM_SETTEXTLIMIT,(MPARAM)1,NULL);
WinSetWindowText(WinWindowFromID(hwnd,303),&punit->chDrive);
break;
case WM_COMMAND:
if((SHORT)mp1==DID_OK)
WinQueryWindowText(WinWindowFromID(hwnd,303),2,&punit->chDrive);
punit->chDrive = toupper(punit->chDrive);
break;
}
return WinDefDlgProc(hwnd,msg,mp1,mp2);
}

MRESULT EXPENTRY diskmonwndproc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
struct {
ULONG filesysid;
ULONG sectornum;
ULONG unitnum;
ULONG unitavail;
USHORT bytesnum;
} level1;
HWND hwndMon;
PUNITDISKMON punit;
HPS hps;
RECTL rcl;
ULONG x;
char buf[80];
punit = (PUNITDISKMON)WinQueryWindowULong(hwnd,0L);
switch(msg)
{
case WM_CREATE:
punit = (PUNITDISKMON)mp1;
WinSetWindowULong(hwnd,0L,(ULONG)punit);
if(!punit->bZero)
{

punit->lfc = 0L;
punit->lbc = 0x00CCCCCCL;
strcpy(punit->szFont,"8.Helv");
punit->bZero = 1;
punit->chDrive = 'C';
}

DosQueryFSInfo((ULONG)(punit->chDrive-64), 1, (PVOID)&level1, sizeof(level1));
sprintf(buf,"%c: %luM Free",punit->chDrive,level1.sectornum*level1.unitavail/2048);

WinQueryWindowRect(hwnd, &rcl);
hwndMon = WinCreateWindow(hwnd, WC_STATIC, buf, WS_VISIBLE | SS_TEXT |
                DT_CENTER | DT_VCENTER, rcl.yTop-4, 1, rcl.xRight-20,
                rcl.yTop-2, hwnd, HWND_TOP, 100, NULL, NULL);
WinSetPresParam(hwndMon, PP_FONTNAMESIZE,80,punit->szFont);
WinSetPresParam(hwndMon, PP_BACKGROUNDCOLOR,sizeof(LONG),&punit->lbc);
WinSetPresParam(hwndMon, PP_FOREGROUNDCOLOR,sizeof(LONG),&punit->lfc);
WinStartTimer(habMain, hwnd, 1, 15000);
WinSendMsg(WinQueryWindow(hwnd,QW_PARENT),WM_USER,(MPARAM)hwnd,
           (MPARAM)szHelp);
break;
case WM_TIMER:
DosQueryFSInfo((ULONG)(punit->chDrive-64), 1, (PVOID)&level1, sizeof(level1));
sprintf(buf,"%c: %luM Free",punit->chDrive,level1.sectornum*level1.unitavail/2048);
WinSetWindowText(WinWindowFromID(hwnd,100),buf);
break;
case WM_SIZE:
WinSetWindowPos(WinWindowFromID(hwnd,100),HWND_TOP,SHORT2FROMMP(mp2)-4,1,
                SHORT1FROMMP(mp2)-20,SHORT2FROMMP(mp2)-2,SWP_SIZE | SWP_MOVE);
break;
case WM_PAINT:
hps = WinBeginPaint(hwnd,NULL,NULL);
WinQueryWindowRect(hwnd, &rcl);
WinFillRect(hps, &rcl, CLR_PALEGRAY);
WinDrawBorder(hps,&rcl,1,1,CLR_DARKGRAY,CLR_WHITE,0x800L);
paintpointer(hps,2,3,rcl.yTop-7,rcl.yTop-7,hptrDiskIcon);
WinDrawBorder(hps,&rcl,1,1,CLR_DARKGRAY,CLR_WHITE,0x800L);
WinEndPaint(hps);
WinQueryPresParam(WinWindowFromID(hwnd,100), PP_FONTNAMESIZE,NULL,&x,80,buf,0);
strcpy(punit->szFont,buf);
WinQueryPresParam(WinWindowFromID(hwnd,100), PP_BACKGROUNDCOLOR,NULL,&x,sizeof(LONG),&punit->lbc,QPF_PURERGBCOLOR);
WinQueryPresParam(WinWindowFromID(hwnd,100), PP_FOREGROUNDCOLOR,NULL,&x,sizeof(LONG),&punit->lfc,QPF_PURERGBCOLOR);
return (MRESULT) NULL;
case WM_COMMAND:
switch((SHORT)mp1)
{
case 100:
WinDlgBox(HWND_DESKTOP,(HWND)mp2,(PFNWP)diskmondlgproc,hmod,300,(PVOID)punit);
WinPostMsg(hwnd,WM_TIMER,(MPARAM)0L,(MPARAM)0L);
break;
}
return (MRESULT) NULL;
case WM_DESTROY:
//free(punit);
DosFreeMem(punit);
break;
}
return WinDefWindowProc(hwnd,msg,mp1,mp2);
}


void diskmonregisterclass(PWCLASS pwc)
{
strcpy(pwc->szName,szDiskClass);
pwc->ulCfgSize = sizeof(UNITDISKMON);
pwc->ulSafeAlloc = sizeof(UNITDISKMON);
pwc->bInitalUnitWidthPercent = 10;
WinRegisterClass(habMain,(PSZ)szDiskClass,(PFNWP)diskmonwndproc,CS_SIZEREDRAW,8L);
hptrDiskIcon = WinLoadPointer(HWND_DESKTOP,hmod,300);
}
